Home | Download | Screen shots | Discussion | Documentation
--- | --- | --- | --- | ---

# openvrml::material_node Class Reference

Abstract base class for material nodes. More...

`#include <openvrml/node.h>`

Inheritance diagram for openvrml::material_node:
[legend]

List of all members.

## Public Member Functions

virtual | ~material_node ()=0 throw ()
| Destroy.
float | ambient_intensity () const throw ()
| Get the ambient intensity.
const color & | diffuse_color () const throw ()
| Get the diffuse color.
const color & | emissive_color () const throw ()
| Get the emissive color.
float | shininess () const throw ()
| Get the shininess.
const color & | specular_color () const throw ()
| Get the specular color.
float | transparency () const throw ()
| Get the transparency.

## Protected Member Functions

| material_node (const node_type &type, const boost::shared_ptr< openvrml::scope > &scope) throw ()
| Construct.

## Private Member Functions

virtual material_node * | to_material () throw ()
| Cast to a `material_node`.
virtual float | do_ambient_intensity () const =0 throw ()
| Get the ambient intensity.
virtual const color & | do_diffuse_color () const =0 throw ()
| Get the diffuse color.
virtual const color & | do_emissive_color () const =0 throw ()
| Get the emissive color.
virtual float | do_shininess () const =0 throw ()
| Get the shininess.
virtual const color & | do_specular_color () const =0 throw ()
| Get the specular color.
virtual float | do_transparency () const =0 throw ()
| Get the transparency.

## Detailed Description

Abstract base class for material nodes.

## Constructor & Destructor Documentation

openvrml::material_node::~material_node | ( |  | ) | throw ()`[pure virtual]`

Destroy.

openvrml::material_node::material_node | ( | const node_type & | type,
|  | const boost::shared_ptr< openvrml::scope > & | scope |
| ) |  |  | throw ()`[protected]`

Construct.

Parameters:

  `[in]` | type | the `node_type` associated with the node.
  `[in]` | scope | the `scope` the node belongs to.

## Member Function Documentation

float openvrml::material_node::ambient_intensity | ( |  | ) | const throw ()

Get the ambient intensity.

This function delegates to `do_ambient_intensity`.

Returns:
  the ambient intensity.

const openvrml::color & openvrml::material_node::diffuse_color | ( |  | ) | const throw ()

Get the diffuse color.

This function delegatest to `do_diffuse_color`.

Returns:
  the diffuse color.

const openvrml::color & openvrml::material_node::emissive_color | ( |  | ) | const throw ()

Get the emissive color.

This function delegates to `do_emissive_color`.

Returns:
  the emissive color.

float openvrml::material_node::shininess | ( |  | ) | const throw ()

Get the shininess.

This function delegates to `do_shininess`.

Returns:
  the shininess.

const openvrml::color & openvrml::material_node::specular_color | ( |  | ) | const throw ()

Get the specular color.

This function delegates to `do_specular_color`.

Returns:
  the specular color.

float openvrml::material_node::transparency | ( |  | ) | const throw ()

Get the transparency.

This function delegates to `do_transparency`.

Returns:
  the transparency.

openvrml::material_node * openvrml::material_node::to_material | ( |  | ) | throw ()`[private, virtual]`

Cast to a `material_node`.

Returns:
  a pointer to this `material_node`.

Reimplemented from openvrml::node.

float openvrml::material_node::do_ambient_intensity | ( |  | ) | const throw ()`[private, pure virtual]`

Get the ambient intensity.

Returns:
  the ambient intensity.

const openvrml::color & openvrml::material_node::do_diffuse_color | ( |  | ) | const throw ()`[private, pure virtual]`

Get the diffuse color.

Returns:
  the diffuse color.

const openvrml::color & openvrml::material_node::do_emissive_color | ( |  | ) | const throw ()`[private, pure virtual]`

Get the emissive color.

Returns:
  the emissive color.

float openvrml::material_node::do_shininess | ( |  | ) | const throw ()`[private, pure virtual]`

Get the shininess.

Returns:
  the shininess.

const openvrml::color & openvrml::material_node::do_specular_color | ( |  | ) | const throw ()`[private, pure virtual]`

Get the specular color.

Returns:
  the specular color.

float openvrml::material_node::do_transparency | ( |  | ) | const throw ()`[private, pure virtual]`

Get the transparency.

Returns:
  the transparency.